#include "stc32g.h"
#include "stdio.h"
#include "math.h"

#define FOSC        56000000UL
#define BAUD        (65536 - FOSC/4/115200)

void ICacheOn()
{
    bit fEA;
    
    if (WTST > 0)               //WTSTΪ0ʱҪҲʹICACHE
    {
        fEA = EA;               //EA
        EA = 0;                 //رж
        _nop_();
        _nop_();
        TA = 0xaa;              //д봥1
                                //˴κָ
        TA = 0x55;              //д봥2
                                //˴κָ
        ICHECR = 0x01;          //дʱرգ޸ICHECRеENλ
                                //ENλٴνд״̬
        _nop_();
        _nop_();
        EA = fEA;               //ָEA
    }
}

void main(void)
{
    unsigned long v;
    float f;
    bit b;
    int i;

    ICacheOn();
    
    AUXR = 0x40;
    SCON = 0x52;
    TMOD = 0x00;
    TL1 = BAUD;
    TH1 = BAUD >> 8;
    TR1 = 1;
    
    printf("Test STC32F12K54 FPMU && MDU32 !\n");
    

    //˳
    TL0 = 0x00;
    TH0 = 0x00;
    TR0 = 1;
    v = 1;
    for (i = 0; i < 10; i++)
    {
        v *= 2L;                    //?C?LIMUL     
        v *= 1234562L;              //?C?LMUL      
        v /= 3;                     //?C?ULIDIV    
        v /= 123453;                //?C?ULDIV     
        v = (long)v / 3;            //?C?SLDIV     
    }
    TR0 = 0;
    printf("MDU32 : %u\n", (TH0 << 8) | TL0);

    //
    TL0 = 0x00;
    TH0 = 0x00;
    TR0 = 1;
    for (i = 0; i < 10; i++)
    {
        f = 12341.234546;
        f += 345462.345678;         //?C?FPADD     
        f = 12341.234546;
        f -= 74463.345678;          //?C?FPSUB     
        f = 12341.234546;
        f *= 897654.3456788;        //?C?FPMUL     
        f = 12341.234546;
        f /= 9876565.232345;        //?C?FPDIV     
        f = 12341.234546;
        f = sqrt(f);                //sqrt?_       
        f = 12341.234546;
        b = f > 1.0;                //?C?FPCMP3    
        f = 12341.234546;
        f = -f;                     //?C?FPNEG     
        f = 12341.234546;
        f = fabs(f);                //fabs?_       
    }
    TR0 = 0;
    printf("FPMU : %u\n", (TH0 << 8) | TL0);

    //Ǻ
    TL0 = 0x00;
    TH0 = 0x00;
    TR0 = 1;
    for (i = 0; i < 10; i++)
    {
        f = 12341.234546;
        f = sin(f);                 //sin?_        
        f = 12341.234546;
        f = cos(f);                 //cos?_        
        f = 12341.234546;
        f = tan(f);                 //tan?_        
        f = 12341.234546;
        f = atan(f);                //atan?_       
    }
    TR0 = 0;
    printf("SIN : %u\n", (TH0 << 8) | TL0);

	while(1);
}
